* [xfstests PATCH v3 0/5] overlay: add fsck.overlay basic tests
@ 2018-02-08 3:19 zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 1/5] overlay: add filesystem check helper zhangyi (F)
` (4 more replies)
0 siblings, 5 replies; 7+ messages in thread
From: zhangyi (F) @ 2018-02-08 3:19 UTC (permalink / raw)
To: eguan, fstests
Cc: linux-unionfs, miklos, amir73il, yi.zhang, miaoxie, yangerkun
Hi Eryu:
This revision handle your comments in last iteration, please review.
Thanks,
Yi.
Changes since v2:
- Move overlayfs xattrs constants to common/overlay.
- Fix _require_attrs in 201 and 203.
- Fix syntax error in string compare, and modify fsck error handle.
- Modify some code style.
Changes since v1:
- improve _overlay_fsck_dirs helper to accept more than one options.
----------
Background:
This is the test cases for the fsck.overlay[1] to test orphan whiteout,
invalid/duplicate reiderct dirs, and the missing impure xattr. These
works only when fsck.overlay exists. (These patchset split form origin
patchset[2])
[1] https://github.com/hisilicon/overlayfs-progs
[2] https://www.spinics.net/lists/linux-unionfs/msg03988.html
zhangyi (F) (5):
overlay: add filesystem check helper
overlay: define common overlay xattr keys
overlay: add fsck.overlay whiteout test
overlay: add fsck.overlay redirect directory test
overlay: add fsck.overlay impure xattr test
common/config | 1 +
common/overlay | 24 +++++
tests/overlay/201 | 228 +++++++++++++++++++++++++++++++++++++++++++
tests/overlay/201.out | 10 ++
tests/overlay/202 | 264 ++++++++++++++++++++++++++++++++++++++++++++++++++
tests/overlay/202.out | 11 +++
tests/overlay/203 | 141 +++++++++++++++++++++++++++
tests/overlay/203.out | 4 +
tests/overlay/group | 3 +
9 files changed, 686 insertions(+)
create mode 100755 tests/overlay/201
create mode 100644 tests/overlay/201.out
create mode 100755 tests/overlay/202
create mode 100644 tests/overlay/202.out
create mode 100755 tests/overlay/203
create mode 100644 tests/overlay/203.out
--
2.5.0
^ permalink raw reply [flat|nested] 7+ messages in thread
* [xfstests PATCH v3 1/5] overlay: add filesystem check helper
2018-02-08 3:19 [xfstests PATCH v3 0/5] overlay: add fsck.overlay basic tests zhangyi (F)
@ 2018-02-08 3:19 ` zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 2/5] overlay: define common overlay xattr keys zhangyi (F)
` (3 subsequent siblings)
4 siblings, 0 replies; 7+ messages in thread
From: zhangyi (F) @ 2018-02-08 3:19 UTC (permalink / raw)
To: eguan, fstests
Cc: linux-unionfs, miklos, amir73il, yi.zhang, miaoxie, yangerkun
Add filesystem check helper for the upcoming fsck.overlay utility.
This helper invoke fsck.overlay to check and optionally repair
underlying directories of overlay filesystem.
Signed-off-by: zhangyi (F) <yi.zhang@huawei.com>
Reviewed-by: Amir Goldstein <amir73il@gmail.com>
---
common/config | 1 +
common/overlay | 14 ++++++++++++++
2 files changed, 15 insertions(+)
diff --git a/common/config b/common/config
index 5f40413..71115bd 100644
--- a/common/config
+++ b/common/config
@@ -236,6 +236,7 @@ case "$HOSTOS" in
export MKFS_REISER4_PROG="`set_prog_path mkfs.reiser4`"
export E2FSCK_PROG="`set_prog_path e2fsck`"
export TUNE2FS_PROG="`set_prog_path tune2fs`"
+ export FSCK_OVERLAY_PROG="`set_prog_path fsck.overlay`"
;;
esac
diff --git a/common/overlay b/common/overlay
index ad2f3be..16f13a8 100644
--- a/common/overlay
+++ b/common/overlay
@@ -168,3 +168,17 @@ _require_scratch_overlay_features()
_scratch_unmount
}
+
+# Helper function to check underlying dirs of overlay filesystem
+_overlay_fsck_dirs()
+{
+ local lowerdir=$1
+ local upperdir=$2
+ local workdir=$3
+ shift 3
+
+ [[ ! -x "$FSCK_OVERLAY_PROG" ]] && return 0
+
+ $FSCK_OVERLAY_PROG -o lowerdir=$lowerdir -o upperdir=$upperdir \
+ -o workdir=$workdir $*
+}
--
2.5.0
^ permalink raw reply related [flat|nested] 7+ messages in thread
* [xfstests PATCH v3 2/5] overlay: define common overlay xattr keys
2018-02-08 3:19 [xfstests PATCH v3 0/5] overlay: add fsck.overlay basic tests zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 1/5] overlay: add filesystem check helper zhangyi (F)
@ 2018-02-08 3:19 ` zhangyi (F)
2018-02-08 12:06 ` Eryu Guan
2018-02-08 3:19 ` [xfstests PATCH v3 3/5] overlay: add fsck.overlay whiteout test zhangyi (F)
` (2 subsequent siblings)
4 siblings, 1 reply; 7+ messages in thread
From: zhangyi (F) @ 2018-02-08 3:19 UTC (permalink / raw)
To: eguan, fstests
Cc: linux-unionfs, miklos, amir73il, yi.zhang, miaoxie, yangerkun
Define common overlay xattr keys from Linux kernel for ovl tests use.
Signed-off-by: zhangyi (F) <yi.zhang@huawei.com>
---
common/overlay | 10 ++++++++++
1 file changed, 10 insertions(+)
diff --git a/common/overlay b/common/overlay
index 16f13a8..9000432 100644
--- a/common/overlay
+++ b/common/overlay
@@ -3,6 +3,16 @@
#
. ./common/module
+# Export overlayfs xattrs and constant value
+export OVL_XATTR_OPAQUE="trusted.overlay.opaque"
+export OVL_XATTR_REDIRECT="trusted.overlay.redirect"
+export OVL_XATTR_IMPURE="trusted.overlay.impure"
+export OVL_XATTR_ORIGIN="trusted.overlay.origin"
+export OVL_XATTR_NLINK="trusted.overlay.nlink"
+export OVL_XATTR_UPPER="trusted.overlay.upper"
+export OVL_XATTR_OPAQUE_VAL="y"
+export OVL_XATTR_IMPURE_VAL="y"
+
# helper function to do the actual overlayfs mount operation
_overlay_mount_dirs()
{
--
2.5.0
^ permalink raw reply related [flat|nested] 7+ messages in thread
* [xfstests PATCH v3 3/5] overlay: add fsck.overlay whiteout test
2018-02-08 3:19 [xfstests PATCH v3 0/5] overlay: add fsck.overlay basic tests zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 1/5] overlay: add filesystem check helper zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 2/5] overlay: define common overlay xattr keys zhangyi (F)
@ 2018-02-08 3:19 ` zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 4/5] overlay: add fsck.overlay redirect directory test zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 5/5] overlay: add fsck.overlay impure xattr test zhangyi (F)
4 siblings, 0 replies; 7+ messages in thread
From: zhangyi (F) @ 2018-02-08 3:19 UTC (permalink / raw)
To: eguan, fstests
Cc: linux-unionfs, miklos, amir73il, yi.zhang, miaoxie, yangerkun
Add fsck.overlay test case to test it how to deal with orphan/valid
whiteouts in underlying directories of overlayfs.
Signed-off-by: zhangyi (F) <yi.zhang@huawei.com>
Reviewed-by: Amir Goldstein <amir73il@gmail.com>
---
tests/overlay/201 | 228 ++++++++++++++++++++++++++++++++++++++++++++++++++
tests/overlay/201.out | 10 +++
tests/overlay/group | 1 +
3 files changed, 239 insertions(+)
create mode 100755 tests/overlay/201
create mode 100644 tests/overlay/201.out
diff --git a/tests/overlay/201 b/tests/overlay/201
new file mode 100755
index 0000000..7c41a9b
--- /dev/null
+++ b/tests/overlay/201
@@ -0,0 +1,228 @@
+#! /bin/bash
+# FS QA Test 201
+#
+# Test fsck.overlay how to deal with whiteouts in overlayfs.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2018 Huawei. All Rights Reserved.
+# Author: zhangyi (F) <yi.zhang@huawei.com>
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs overlay
+_supported_os Linux
+_require_scratch_nocheck
+_require_attrs
+_require_command "$FSCK_OVERLAY_PROG" fsck.overlay
+
+# remove all files from previous tests
+_scratch_mkfs
+
+# Check whiteout
+check_whiteout()
+{
+ for arg in $*; do
+ local ttype=`stat -c "%F:%t,%T" $arg`
+
+ [[ "$ttype" == "character special file:0,0" ]] || \
+ echo "Valid whiteout removed incorrectly"
+ done
+}
+
+# Create a whiteout
+make_whiteout()
+{
+ for arg in $*; do
+ mknod $arg c 0 0
+ done
+}
+
+# Create an opaque directory
+make_opaque_dir()
+{
+ local target=$1
+
+ mkdir -p $target
+ $SETFATTR_PROG -n $OVL_XATTR_OPAQUE -v $OVL_XATTR_OPAQUE_VAL $target
+}
+
+# Create a redirect directory
+make_redirect_dir()
+{
+ local target=$1
+ local value=$2
+
+ mkdir -p $target
+ $SETFATTR_PROG -n $OVL_XATTR_REDIRECT -v $value $target
+}
+
+# Create test directories
+lowerdir=$OVL_BASE_SCRATCH_MNT/lower
+lowerdir2=$OVL_BASE_SCRATCH_MNT/lower2
+upperdir=$OVL_BASE_SCRATCH_MNT/upper
+workdir=$OVL_BASE_SCRATCH_MNT/workdir
+
+make_test_dirs()
+{
+ rm -rf $lowerdir $lowerdir2 $upperdir $workdir
+ mkdir -p $lowerdir $lowerdir2 $upperdir $workdir
+}
+
+# Test orphan whiteout in lower and upper layer, should remove
+echo "+ Orphan whiteout"
+make_test_dirs
+make_whiteout $lowerdir/foo $upperdir/{foo,bar}
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+ls $lowerdir
+ls $upperdir
+
+# Test valid whiteout covering lower target, should not remove
+echo "+ Valid whiteout"
+make_test_dirs
+touch $lowerdir2/{foo,bar}
+make_whiteout $upperdir/foo $lowerdir/bar
+
+_overlay_fsck_dirs "$lowerdir:$lowerdir2" $upperdir $workdir -p >> \
+ $seqres.full 2>&1 || echo "fsck should not fail"
+check_whiteout $upperdir/foo $lowerdir/bar
+
+# Test orphan whiteout in opaque directory, should remove
+echo "+ Orphan whiteout(2)"
+make_test_dirs
+mkdir $lowerdir/testdir
+touch $lowerdir/testdir/foo
+make_opaque_dir $upperdir/testdir
+make_whiteout $upperdir/testdir/foo
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+ls $upperdir/testdir
+
+# Test orphan whiteout whose parent path is not an merged directory,
+# should remove
+echo "+ Orphan whiteout(3)"
+make_test_dirs
+mkdir $lowerdir2/{testdir1,testdir2,testdir3}
+touch $lowerdir2/{testdir1/foo,testdir2/foo,testdir3/foo}
+mkdir $upperdir/{testdir1,testdir2,testdir3,testdir4}
+touch $lowerdir/testdir1
+make_whiteout $lowerdir/testdir2
+make_opaque_dir $lowerdir/testdir3
+make_whiteout $upperdir/{testdir1/foo,/testdir2/foo,testdir3/foo,testdir4/foo}
+
+_overlay_fsck_dirs "$lowerdir:$lowerdir2" $upperdir $workdir -p >> \
+ $seqres.full 2>&1 || echo "fsck should not fail"
+ls $upperdir/testdir1
+ls $upperdir/testdir2
+ls $upperdir/testdir3
+ls $upperdir/testdir4
+
+# Test orphan whiteout in redirect directory, should remove
+echo "+ Orphan whiteout(4)"
+make_test_dirs
+mkdir $lowerdir/{testdir,origin}
+touch $lowerdir/testdir/foo
+make_redirect_dir $upperdir/testdir "origin"
+make_whiteout $upperdir/testdir/foo
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+ls $upperdir/testdir
+
+# Test valid whiteout in redirect directory cover file in lower
+# redirect origin directory, should not remove
+echo "+ Valid whiteout(2)"
+make_test_dirs
+mkdir $lowerdir/origin
+touch $lowerdir/origin/foo
+make_redirect_dir $upperdir/testdir "origin"
+make_whiteout $upperdir/testdir/foo
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_whiteout $upperdir/testdir/foo
+
+# Test valid whiteout covering lower target whose parent directory
+# merge with a redirect directory in the middle layer, should not remove.
+echo "+ Valid whiteout(3)"
+make_test_dirs
+mkdir -p $lowerdir2/origin/subdir
+touch $lowerdir2/origin/subdir/foo
+make_redirect_dir $lowerdir/testdir "origin"
+mkdir -p $upperdir/testdir/subdir
+make_whiteout $upperdir/testdir/subdir/foo
+
+_overlay_fsck_dirs "$lowerdir:$lowerdir2" $upperdir $workdir -p \
+ >> $seqres.full 2>&1 || echo "fsck should not fail"
+check_whiteout $upperdir/testdir/subdir/foo
+
+# Test invalid whiteout in opaque subdirectory in a redirect directory,
+# should remove
+echo "+ Orphan whiteout(5)"
+make_test_dirs
+mkdir -p $lowerdir/origin/subdir
+touch $lowerdir/origin/subdir/foo
+make_redirect_dir $upperdir/testdir "origin"
+make_opaque_dir $upperdir/testdir/subdir
+make_whiteout $upperdir/testdir/subdir/foo
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+ls $upperdir/testdir/subdir
+
+# Test valid whiteout in reidrect subdirectory in a opaque directory
+# covering lower target, should not remove
+echo "+ Valid whiteout(4)"
+make_test_dirs
+mkdir $lowerdir/origin
+touch $lowerdir/origin/foo
+make_opaque_dir $upperdir/testdir
+make_redirect_dir $upperdir/testdir/subdir "/origin"
+make_whiteout $upperdir/testdir/subdir/foo
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_whiteout $upperdir/testdir/subdir/foo
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/201.out b/tests/overlay/201.out
new file mode 100644
index 0000000..157bb85
--- /dev/null
+++ b/tests/overlay/201.out
@@ -0,0 +1,10 @@
+QA output created by 201
++ Orphan whiteout
++ Valid whiteout
++ Orphan whiteout(2)
++ Orphan whiteout(3)
++ Orphan whiteout(4)
++ Valid whiteout(2)
++ Valid whiteout(3)
++ Orphan whiteout(5)
++ Valid whiteout(4)
diff --git a/tests/overlay/group b/tests/overlay/group
index 40c1a05..50e0d5b 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -56,3 +56,4 @@
053 auto quick copyup redirect exportfs nonsamefs
054 auto quick copyup redirect exportfs
055 auto quick copyup redirect exportfs nonsamefs
+201 auto quick fsck
--
2.5.0
^ permalink raw reply related [flat|nested] 7+ messages in thread
* [xfstests PATCH v3 4/5] overlay: add fsck.overlay redirect directory test
2018-02-08 3:19 [xfstests PATCH v3 0/5] overlay: add fsck.overlay basic tests zhangyi (F)
` (2 preceding siblings ...)
2018-02-08 3:19 ` [xfstests PATCH v3 3/5] overlay: add fsck.overlay whiteout test zhangyi (F)
@ 2018-02-08 3:19 ` zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 5/5] overlay: add fsck.overlay impure xattr test zhangyi (F)
4 siblings, 0 replies; 7+ messages in thread
From: zhangyi (F) @ 2018-02-08 3:19 UTC (permalink / raw)
To: eguan, fstests
Cc: linux-unionfs, miklos, amir73il, yi.zhang, miaoxie, yangerkun
Add fsck.overlay test case to test it how to deal with invalid/valid/
duplicate redirect xattr in underlying directories of overlayfs.
Signed-off-by: zhangyi (F) <yi.zhang@huawei.com>
Reviewed-by: Amir Goldstein <amir73il@gmail.com>
---
tests/overlay/202 | 264 ++++++++++++++++++++++++++++++++++++++++++++++++++
tests/overlay/202.out | 11 +++
tests/overlay/group | 1 +
3 files changed, 276 insertions(+)
create mode 100755 tests/overlay/202
create mode 100644 tests/overlay/202.out
diff --git a/tests/overlay/202 b/tests/overlay/202
new file mode 100755
index 0000000..a1e1f84
--- /dev/null
+++ b/tests/overlay/202
@@ -0,0 +1,264 @@
+#! /bin/bash
+# FS QA Test 202
+#
+# Test fsck.overlay how to deal with redirect xattr in overlayfs.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2018 Huawei. All Rights Reserved.
+# Author: zhangyi (F) <yi.zhang@huawei.com>
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs overlay
+_supported_os Linux
+_require_scratch_nocheck
+_require_attrs
+_require_command "$FSCK_OVERLAY_PROG" fsck.overlay
+
+# remove all files from previous tests
+_scratch_mkfs
+
+# Create a redirect directory
+make_redirect_dir()
+{
+ local target=$1
+ local value=$2
+
+ mkdir -p $target
+ $SETFATTR_PROG -n $OVL_XATTR_REDIRECT -v $value $target
+}
+
+# Check redirect xattr
+check_redirect()
+{
+ local target=$1
+ local expect=$2
+
+ value=$($GETFATTR_PROG --absolute-names --only-values -n \
+ $OVL_XATTR_REDIRECT $target)
+
+ [[ "$value" == "$expect" ]] || echo "Redirect xattr incorrect"
+}
+
+check_no_redirect()
+{
+ local target=$1
+
+ value=$($GETFATTR_PROG --absolute-names -d -m \
+ $OVL_XATTR_REDIRECT $target)
+
+ [[ -z "$value" ]] || echo "Redirect xattr not empty"
+}
+
+# Check opaque xattr
+check_opaque()
+{
+ local target=$1
+
+ value=$($GETFATTR_PROG --absolute-names --only-values -n \
+ $OVL_XATTR_OPAQUE $target)
+
+ [[ "$value" == "$OVL_XATTR_OPAQUE_VAL" ]] || \
+ echo "Opaque xattr incorrect"
+}
+
+# Create a whiteout
+make_whiteout()
+{
+ for arg in $*; do
+ mknod $arg c 0 0
+ done
+}
+
+# Check whiteout
+check_whiteout()
+{
+ for arg in $*; do
+ local ttype=`stat -c "%F:%t,%T" $arg`
+
+ [[ "$ttype" == "character special file:0,0" ]] || \
+ echo "Valid whiteout removed incorrectly"
+ done
+}
+
+# Create test directories
+lowerdir=$OVL_BASE_SCRATCH_MNT/lower
+lowerdir2=$OVL_BASE_SCRATCH_MNT/lower2
+upperdir=$OVL_BASE_SCRATCH_MNT/upper
+workdir=$OVL_BASE_SCRATCH_MNT/workdir
+
+make_test_dirs()
+{
+ rm -rf $lowerdir $lowerdir2 $upperdir $workdir
+ mkdir -p $lowerdir $lowerdir2 $upperdir $workdir
+}
+
+# Test invalid redirect xattr point to a nonexistent origin, should remove
+echo "+ Invalid redirect"
+make_test_dirs
+make_redirect_dir $upperdir/testdir "invalid"
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_no_redirect $upperdir/testdir
+
+# Test invalid redirect xattr point to a file origin, should remove
+echo "+ Invalid redirect(2)"
+make_test_dirs
+touch $lowerdir/origin
+make_redirect_dir $upperdir/testdir "origin"
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_no_redirect $upperdir/testdir
+
+# Test valid redirect xattr point to a directory origin in the same directory,
+# should not remove
+echo "+ Valid redirect"
+make_test_dirs
+mkdir $lowerdir/origin
+make_whiteout $upperdir/origin
+make_redirect_dir $upperdir/testdir "origin"
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_redirect $upperdir/testdir "origin"
+
+# Test valid redirect xattr point to a directory origin in different directories
+# should not remove
+echo "+ Valid redirect(2)"
+make_test_dirs
+mkdir $lowerdir/origin
+make_whiteout $upperdir/origin
+make_redirect_dir $upperdir/testdir1/testdir2 "/origin"
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_redirect $upperdir/testdir1/testdir2 "/origin"
+
+# Test valid redirect xattr but missing whiteout to cover lower target,
+# should fix whiteout
+echo "+ Missing whiteout"
+make_test_dirs
+mkdir $lowerdir/origin
+make_redirect_dir $upperdir/testdir "origin"
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_redirect $upperdir/testdir "origin"
+check_whiteout $upperdir/origin
+
+# Test valid redirect xattrs exchanged by rename, should not remove
+echo "+ Valid redirect(3)"
+make_test_dirs
+mkdir $lowerdir/{testdir1,testdir2}
+make_redirect_dir $upperdir/testdir1 "testdir2"
+make_redirect_dir $upperdir/testdir2 "testdir1"
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_redirect $upperdir/testdir1 "testdir2"
+check_redirect $upperdir/testdir2 "testdir1"
+
+# Test invalid redirect xattr with lower same name directory exists,
+# should remove invalid redirect xattr and set opaque in yes mode
+echo "+ Invalid redirect(3)"
+make_test_dirs
+mkdir $lowerdir/testdir
+make_redirect_dir $upperdir/testdir "invalid"
+
+# Question get yes answer: Should set opaque dir ?
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -y >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_no_redirect $upperdir/testdir
+check_opaque $upperdir/testdir
+
+# Test duplicate redirect xattrs point to one origin, should fail in
+# auto mode, and should remove either of the duplicates in yes mode
+echo "+ Duplicate redirect"
+make_test_dirs
+mkdir $lowerdir2/origin
+make_redirect_dir $lowerdir/testdir1 "origin"
+make_redirect_dir $lowerdir/testdir2 "origin"
+make_redirect_dir $upperdir/testdir3 "origin"
+
+_overlay_fsck_dirs "$lowerdir:$lowerdir2" $upperdir $workdir -p >> \
+ $seqres.full 2>&1 && echo "fsck should fail"
+
+# Question get yes answer: Duplicate redirect directory, remove xattr ?
+_overlay_fsck_dirs "$lowerdir:$lowerdir2" $upperdir $workdir -y >> \
+ $seqres.full 2>&1 || echo "fsck should not fail"
+redirect_1=`check_redirect $lowerdir/testdir1 "origin" 2>/dev/null`
+redirect_2=`check_redirect $lowerdir/testdir2 "origin" 2>/dev/null`
+[[ $redirect_1 == $redirect_2 ]] && echo "Redirect xattr incorrect"
+check_no_redirect $upperdir/testdir3
+
+# Test duplicate redirect xattr duplicate with merge directory, should
+# fail in auto mode, and should remove the redirect xattr in yes mode
+echo "+ Duplicate redirect(2)"
+make_test_dirs
+mkdir $lowerdir/origin $upperdir/origin
+make_redirect_dir $upperdir/testdir "origin"
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 && \
+ echo "fsck should fail"
+
+# Question get yes answer: Duplicate redirect directory, remove xattr ?
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -y >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_no_redirect $upperdir/testdir
+
+# Test duplicate redirect xattr with lower same name directory exists,
+# should remove the duplicate redirect xattr and set opaque in yes mode
+echo "+ Duplicate redirect(3)"
+make_test_dirs
+mkdir $lowerdir/{origin,testdir} $upperdir/origin
+make_redirect_dir $upperdir/testdir "invalid"
+
+# Question one get yes answer: Duplicate redirect directory, remove xattr?
+# Question two get yes answer: Should set opaque dir ?
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -y >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_no_redirect $upperdir/testdir
+check_opaque $upperdir/testdir
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/202.out b/tests/overlay/202.out
new file mode 100644
index 0000000..99d2b32
--- /dev/null
+++ b/tests/overlay/202.out
@@ -0,0 +1,11 @@
+QA output created by 202
++ Invalid redirect
++ Invalid redirect(2)
++ Valid redirect
++ Valid redirect(2)
++ Missing whiteout
++ Valid redirect(3)
++ Invalid redirect(3)
++ Duplicate redirect
++ Duplicate redirect(2)
++ Duplicate redirect(3)
diff --git a/tests/overlay/group b/tests/overlay/group
index 50e0d5b..7746514 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -57,3 +57,4 @@
054 auto quick copyup redirect exportfs
055 auto quick copyup redirect exportfs nonsamefs
201 auto quick fsck
+202 auto quick fsck
--
2.5.0
^ permalink raw reply related [flat|nested] 7+ messages in thread
* [xfstests PATCH v3 5/5] overlay: add fsck.overlay impure xattr test
2018-02-08 3:19 [xfstests PATCH v3 0/5] overlay: add fsck.overlay basic tests zhangyi (F)
` (3 preceding siblings ...)
2018-02-08 3:19 ` [xfstests PATCH v3 4/5] overlay: add fsck.overlay redirect directory test zhangyi (F)
@ 2018-02-08 3:19 ` zhangyi (F)
4 siblings, 0 replies; 7+ messages in thread
From: zhangyi (F) @ 2018-02-08 3:19 UTC (permalink / raw)
To: eguan, fstests
Cc: linux-unionfs, miklos, amir73il, yi.zhang, miaoxie, yangerkun
Add fsck.overlay test case to test it how to deal with impure
xattr in underlying directories of overlayfs.
Signed-off-by: zhangyi (F) <yi.zhang@huawei.com>
Reviewed-by: Amir Goldstein <amir73il@gmail.com>
---
tests/overlay/203 | 141 ++++++++++++++++++++++++++++++++++++++++++++++++++
tests/overlay/203.out | 4 ++
tests/overlay/group | 1 +
3 files changed, 146 insertions(+)
create mode 100755 tests/overlay/203
create mode 100644 tests/overlay/203.out
diff --git a/tests/overlay/203 b/tests/overlay/203
new file mode 100755
index 0000000..9f1ea79
--- /dev/null
+++ b/tests/overlay/203
@@ -0,0 +1,141 @@
+#! /bin/bash
+# FS QA Test 203
+#
+# Test fsck.overlay how to deal with impure xattr in overlayfs.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2018 Huawei. All Rights Reserved.
+# Author: zhangyi (F) <yi.zhang@huawei.com>
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs overlay
+_supported_os Linux
+_require_scratch_nocheck
+_require_attrs
+_require_command "$FSCK_OVERLAY_PROG" fsck.overlay
+
+# remove all files from previous tests
+_scratch_mkfs
+
+# Create a redirect directory
+make_redirect_dir()
+{
+ local target=$1
+ local value=$2
+
+ mkdir -p $target
+ $SETFATTR_PROG -n $OVL_XATTR_REDIRECT -v $value $target
+}
+
+# Remove impure xattr
+remove_impure()
+{
+ local target=$1
+
+ $SETFATTR_PROG -x $OVL_XATTR_IMPURE $target
+}
+
+# Check impure xattr
+check_impure()
+{
+ local target=$1
+
+ value=$($GETFATTR_PROG --absolute-names --only-values -n \
+ $OVL_XATTR_IMPURE $target)
+
+ [[ "$value" == "$OVL_XATTR_IMPURE_VAL" ]] || echo "Missing impure xattr"
+}
+
+# Create test directories
+lowerdir=$OVL_BASE_SCRATCH_MNT/lower
+lowerdir2=$OVL_BASE_SCRATCH_MNT/lower2
+upperdir=$OVL_BASE_SCRATCH_MNT/upper
+workdir=$OVL_BASE_SCRATCH_MNT/workdir
+
+make_test_dirs()
+{
+ rm -rf $lowerdir $lowerdir2 $upperdir $workdir
+ mkdir -p $lowerdir $lowerdir2 $upperdir $workdir
+}
+
+# Test missing impure xattr in directory which has origin targets, should fix
+echo "+ Missing impure"
+make_test_dirs
+mkdir $lowerdir/{testdir1,testdir2}
+mkdir $upperdir/{testdir1,testdir2}
+touch $lowerdir/testdir1/foo
+mkdir $lowerdir/testdir2/subdir
+_overlay_scratch_mount_dirs $lowerdir $upperdir $workdir
+touch $SCRATCH_MNT/testdir1/foo
+touch $SCRATCH_MNT/testdir2/subdir
+$UMOUNT_PROG $SCRATCH_MNT
+remove_impure $upperdir/testdir1
+remove_impure $upperdir/testdir2
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_impure $upperdir/testdir1
+check_impure $upperdir/testdir2
+
+# Test missing impure xattr in directory which has redirect directories,
+# should fix
+echo "+ Missing impure(2)"
+make_test_dirs
+mkdir $lowerdir/origin
+make_redirect_dir $upperdir/testdir/subdir "/origin"
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_impure $upperdir/testdir
+
+# Test missing impure xattr in directory which has merge directories,
+# should fix
+echo "+ Missing impure(3)"
+make_test_dirs
+mkdir $lowerdir/testdir $upperdir/testdir
+
+_overlay_fsck_dirs $lowerdir $upperdir $workdir -p >> $seqres.full 2>&1 || \
+ echo "fsck should not fail"
+check_impure $upperdir
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/203.out b/tests/overlay/203.out
new file mode 100644
index 0000000..dd81788
--- /dev/null
+++ b/tests/overlay/203.out
@@ -0,0 +1,4 @@
+QA output created by 203
++ Missing impure
++ Missing impure(2)
++ Missing impure(3)
diff --git a/tests/overlay/group b/tests/overlay/group
index 7746514..e8f2d41 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -58,3 +58,4 @@
055 auto quick copyup redirect exportfs nonsamefs
201 auto quick fsck
202 auto quick fsck
+203 auto quick fsck
--
2.5.0
^ permalink raw reply related [flat|nested] 7+ messages in thread
* Re: [xfstests PATCH v3 2/5] overlay: define common overlay xattr keys
2018-02-08 3:19 ` [xfstests PATCH v3 2/5] overlay: define common overlay xattr keys zhangyi (F)
@ 2018-02-08 12:06 ` Eryu Guan
0 siblings, 0 replies; 7+ messages in thread
From: Eryu Guan @ 2018-02-08 12:06 UTC (permalink / raw)
To: zhangyi (F); +Cc: fstests, linux-unionfs, miklos, amir73il, miaoxie, yangerkun
On Thu, Feb 08, 2018 at 11:19:10AM +0800, zhangyi (F) wrote:
> Define common overlay xattr keys from Linux kernel for ovl tests use.
>
> Signed-off-by: zhangyi (F) <yi.zhang@huawei.com>
> ---
> common/overlay | 10 ++++++++++
> 1 file changed, 10 insertions(+)
>
> diff --git a/common/overlay b/common/overlay
> index 16f13a8..9000432 100644
> --- a/common/overlay
> +++ b/common/overlay
> @@ -3,6 +3,16 @@
> #
> . ./common/module
>
> +# Export overlayfs xattrs and constant value
> +export OVL_XATTR_OPAQUE="trusted.overlay.opaque"
> +export OVL_XATTR_REDIRECT="trusted.overlay.redirect"
> +export OVL_XATTR_IMPURE="trusted.overlay.impure"
> +export OVL_XATTR_ORIGIN="trusted.overlay.origin"
> +export OVL_XATTR_NLINK="trusted.overlay.nlink"
> +export OVL_XATTR_UPPER="trusted.overlay.upper"
> +export OVL_XATTR_OPAQUE_VAL="y"
> +export OVL_XATTR_IMPURE_VAL="y"
Sorry, I was not clear enough in previous review. I mean putting the
common xattr keys to common/overlay, but I don't think the <VAL>="y" is
needed.
I'll edit on commit to remove them from here and add them to tests where
needed.
Thanks,
Eryu
> +
> # helper function to do the actual overlayfs mount operation
> _overlay_mount_dirs()
> {
> --
> 2.5.0
>
> --
> To unsubscribe from this list: send the line "unsubscribe fstests" in
> the body of a message to majordomo@vger.kernel.org
> More majordomo info at http://vger.kernel.org/majordomo-info.html
^ permalink raw reply [flat|nested] 7+ messages in thread
end of thread, other threads:[~2018-02-08 12:06 UTC | newest]
Thread overview: 7+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2018-02-08 3:19 [xfstests PATCH v3 0/5] overlay: add fsck.overlay basic tests zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 1/5] overlay: add filesystem check helper zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 2/5] overlay: define common overlay xattr keys zhangyi (F)
2018-02-08 12:06 ` Eryu Guan
2018-02-08 3:19 ` [xfstests PATCH v3 3/5] overlay: add fsck.overlay whiteout test zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 4/5] overlay: add fsck.overlay redirect directory test zhangyi (F)
2018-02-08 3:19 ` [xfstests PATCH v3 5/5] overlay: add fsck.overlay impure xattr test zhangyi (F)
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox